//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "emule.h"
#include "SivkaFileSettings.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CSivkaFileSettings, CDialog)
CSivkaFileSettings::CSivkaFileSettings()
	: CDialog(CSivkaFileSettings::IDD, 0)
{
}

CSivkaFileSettings::~CSivkaFileSettings()
{
}

void CSivkaFileSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSivkaFileSettings, CDialog)
	ON_BN_CLICKED(IDC_AHL_TIMERLABEL, OnBnClickedEnableAutoHL)
	ON_BN_CLICKED(IDC_TAKEOVER, OnBnClickedTakeOver)
	ON_BN_CLICKED(IDC_DEFAULT_BUTTON, OnBnClickedSwitch)
	ON_BN_CLICKED(IDC_HARDLIMIT_TAKEOVER, OnBnClickedMaxSourcesPerFileTakeOver)
	ON_BN_CLICKED(IDC_AHL_TIMERLABEL_TAKEOVER, OnBnClickedEnableAutoHLTakeOver)
	ON_BN_CLICKED(IDC_AHL_TIMER_TAKEOVER, OnBnClickedAutoHL_TimerTakeOver)
END_MESSAGE_MAP()

BOOL CSivkaFileSettings::OnInitDialog()
{
	app_prefs->prefs->m_MaxSourcesPerFileTakeOver = false;
	app_prefs->prefs->m_EnableAutoHLTakeOver = false;
	app_prefs->prefs->m_AutoHL_TimerTakeOver = false;

	m_RestoreDefault = false;
	app_prefs->prefs->m_TakeOverFileSettings = false;
	
	CDialog::OnInitDialog();
	LoadSettings();
	Localize();

	return TRUE;
}

void CSivkaFileSettings::LoadSettings(void)
{
	if(m_hWnd)
	{
		CString strBuffer;
		
		strBuffer.Format("%d", app_prefs->prefs->m_MaxSourcesPerFileTemp);
		GetDlgItem(IDC_HARDLIMIT)->SetWindowText(strBuffer);
		CheckDlgButton(IDC_HARDLIMIT_TAKEOVER, app_prefs->prefs->m_MaxSourcesPerFileTakeOver);
		OnBnClickedMaxSourcesPerFileTakeOver();
		
		CheckDlgButton(IDC_AHL_TIMERLABEL, app_prefs->prefs->m_EnableAutoHLTemp);
		CheckDlgButton(IDC_AHL_TIMERLABEL_TAKEOVER, app_prefs->prefs->m_EnableAutoHLTakeOver);
		strBuffer.Format("%d", app_prefs->prefs->m_AutoHL_TimerTemp/1000);
		GetDlgItem(IDC_AHL_TIMER)->SetWindowText(strBuffer);
		OnBnClickedEnableAutoHLTakeOver();
	}
}

void CSivkaFileSettings::OnBnClickedTakeOver()
{
	char buffer[510];

	app_prefs->prefs->m_MaxSourcesPerFileTakeOver = IsDlgButtonChecked(IDC_HARDLIMIT_TAKEOVER);
	if(GetDlgItem(IDC_HARDLIMIT)->GetWindowTextLength() && app_prefs->prefs->m_MaxSourcesPerFileTakeOver)
	{
		GetDlgItem(IDC_HARDLIMIT)->GetWindowText(buffer,20);
		app_prefs->prefs->m_MaxSourcesPerFileTemp = (atoi(buffer)) ? atoi(buffer) : 1;
	}
	app_prefs->prefs->m_EnableAutoHLTakeOver = IsDlgButtonChecked(IDC_AHL_TIMERLABEL_TAKEOVER);
	if(app_prefs->prefs->m_EnableAutoHLTakeOver)
		app_prefs->prefs->m_EnableAutoHLTemp = IsDlgButtonChecked(IDC_AHL_TIMERLABEL);
	app_prefs->prefs->m_AutoHL_TimerTakeOver = IsDlgButtonChecked(IDC_AHL_TIMER_TAKEOVER);
	if(GetDlgItem(IDC_AHL_TIMER)->GetWindowTextLength() && app_prefs->prefs->m_AutoHL_TimerTakeOver && app_prefs->prefs->m_EnableAutoHLTemp)
	{
		GetDlgItem(IDC_AHL_TIMER)->GetWindowText(buffer,20);
		if (atoi(buffer) >= 0 && atoi(buffer) <= 60)
			app_prefs->prefs->m_AutoHL_TimerTemp = atoi(buffer)*1000;
	}

	LoadSettings();
	app_prefs->prefs->m_TakeOverFileSettings = true;
//	CDialog::OnOK();
}

void CSivkaFileSettings::OnBnClickedSwitch()
{
	if(m_RestoreDefault)
	{
		LoadSettings();
		GetDlgItem(IDC_DEFAULT_BUTTON)->SetWindowText(GetResString(IDS_DEFAULT));
		m_RestoreDefault = false;
	}
	else
	{
		SetWithDefaultValues();
		GetDlgItem(IDC_DEFAULT_BUTTON)->SetWindowText(GetResString(IDS_MAIN_POPUP_RESTORE));
		m_RestoreDefault = true;
	}
}

void CSivkaFileSettings::Localize(void)
{	
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_SIVKAFILESETTINGS));
		GetDlgItem(IDC_HARDLIMIT_LABEL)->SetWindowText(GetResString(IDS_PW_MAXSOURCES));
		GetDlgItem(IDC_AHL_TIMERLABEL)->SetWindowText(GetResString(IDS_AHL_TIMERLABEL));
		GetDlgItem(IDC_TAKEOVER)->SetWindowText(GetResString(IDS_TAKEOVER));
		GetDlgItem(IDC_DEFAULT_BUTTON)->SetWindowText(GetResString(IDS_DEFAULT));
		GetDlgItem(IDOK)->SetWindowText(GetResString(IDS_FD_CLOSE));
	}
}

void CSivkaFileSettings::SetWithDefaultValues()
{
	if(m_hWnd)
	{
		CString strBuffer;

		GetDlgItem(IDC_HARDLIMIT_LABEL)->EnableWindow(true);
		GetDlgItem(IDC_HARDLIMIT)->EnableWindow(true);
		strBuffer.Format("%d", theApp.glob_prefs->GetMaxSourcePerFile());
		GetDlgItem(IDC_HARDLIMIT)->SetWindowText(strBuffer);
		CheckDlgButton(IDC_HARDLIMIT_TAKEOVER, true);
		
		GetDlgItem(IDC_AHL_TIMER)->EnableWindow(theApp.glob_prefs->GetEnableAutoHLDefault());
		GetDlgItem(IDC_AHL_TIMERLABEL)->EnableWindow(true);
		CheckDlgButton(IDC_AHL_TIMERLABEL, theApp.glob_prefs->GetEnableAutoHLDefault());
		CheckDlgButton(IDC_AHL_TIMERLABEL_TAKEOVER, true);
		strBuffer.Format("%d", theApp.glob_prefs->GetAutoHL_TimerDefault()/1000);
		GetDlgItem(IDC_AHL_TIMER)->SetWindowText(strBuffer);
		GetDlgItem(IDC_AHL_TIMER_TAKEOVER)->EnableWindow(theApp.glob_prefs->GetEnableAutoHLDefault());
		CheckDlgButton(IDC_AHL_TIMER_TAKEOVER, theApp.glob_prefs->GetEnableAutoHLDefault());

	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////
void CSivkaFileSettings::OnBnClickedMaxSourcesPerFileTakeOver()
{
	GetDlgItem(IDC_HARDLIMIT)->EnableWindow(IsDlgButtonChecked(IDC_HARDLIMIT_TAKEOVER));
	GetDlgItem(IDC_HARDLIMIT_LABEL)->EnableWindow(IsDlgButtonChecked(IDC_HARDLIMIT_TAKEOVER));
}
void CSivkaFileSettings::OnBnClickedEnableAutoHLTakeOver()
{
	GetDlgItem(IDC_AHL_TIMERLABEL)->EnableWindow(IsDlgButtonChecked(IDC_AHL_TIMERLABEL_TAKEOVER));
	OnBnClickedEnableAutoHL();
}

void CSivkaFileSettings::OnBnClickedEnableAutoHL()
{
	GetDlgItem(IDC_AHL_TIMER_TAKEOVER)->EnableWindow(IsDlgButtonChecked(IDC_AHL_TIMERLABEL) && IsDlgButtonChecked(IDC_AHL_TIMERLABEL_TAKEOVER));
	CheckDlgButton(IDC_AHL_TIMER_TAKEOVER, IsDlgButtonChecked(IDC_AHL_TIMERLABEL) && IsDlgButtonChecked(IDC_AHL_TIMERLABEL_TAKEOVER) && app_prefs->prefs->m_AutoHL_TimerTakeOver);
	OnBnClickedAutoHL_TimerTakeOver();
}

void CSivkaFileSettings::OnBnClickedAutoHL_TimerTakeOver()
{
	GetDlgItem(IDC_AHL_TIMER)->EnableWindow(IsDlgButtonChecked(IDC_AHL_TIMERLABEL) && IsDlgButtonChecked(IDC_AHL_TIMERLABEL_TAKEOVER) && IsDlgButtonChecked(IDC_AHL_TIMER_TAKEOVER));
}
